#include "SDL.h"
#include "WebSrv.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char **argv)
{
	WebSrv *ws;
	WebSrvClient *c;
	TCPsocket s;
	int i=8888;
	
	if(SDL_Init(0)<0)
	{
		printf("Could not initialize SDL: %s.\n", SDL_GetError());
        exit(-1);
	}
	//atexit(SDL_Quit);
	SDLNet_Init();
	//atexit(SDLNet_Quit);
	ws=WebSrv_Create();
	if(argc>1)
		i=strtol(argv[1],NULL,0);
	printf("Starting WebSrv on port %d\n",i);
	s=WebSrv_Open(ws, i);
	if(!s)
	{
		printf("WebSrv_Open failed!\n");
		return(0);
	}
	printf("Connect a web browser to http://localhost:%d\n",i);
	while(WebSrv_Poll(ws, -1)>0)
	{
		if(!(c=WebSrv_Accept(ws)))
			continue; /* just a bad request */
		WebSrv_SendHTTPResponse(c, 200);
		WebSrv_ClientSendString(c, "Content-Type: text/html\r\n\r\n");
		WebSrv_ClientSendString(c, "<html>\r\n<head>\r\n<title>TestWS</title>\r\n</head>\r\n<body>\r\n");
		if(c->url.url && !strcmp(c->url.url,"/Quit"))
		{
			WebSrv_ClientSendString(c, "Goodbye world!\r\n");
			break;
		}
		WebSrv_ClientSendString(c, "Hello world!<p>\r\n");
		/* a get */
		WebSrv_ClientSendString(c, "<form action=/cgi/get method=get>"
				"<input type=text name=user size=80 value=\"nim=nom;and,the*fool (my pal)\"><br>\r\n"
				"<input type=submit value=Get>\r\n"
				"</form><p>\r\n");
		/* a simple post */
		WebSrv_ClientSendString(c, "<form action=/cgi/post method=post>"
				"<input type=text name=user size=80 value=\"dipsy doodle (100% R#A&=geek)\"><br>\r\n"
				"<textarea name=info cols=80 rows=5\">\r\n"
				"This is a textarea!\r\n"
				"~`!@#$%^&*()_+|-=\\{}[]:\";'<>?,./\r\n"
				"1234567890\r\n"
				"abcdefghijklmnopqrstuvwxyz\r\n"
				"ABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n"
				"</textarea><br>\r\n"
				"<input type=submit value=Post>\r\n"
				"</form><p>\r\n");
		/* a multipart post */
		WebSrv_ClientSendString(c, "<form enctype=\"multipart/form-data\" action=/cgi/post method=post>"
				"<input type=text name=user size=80 value=\"dipsy doodle (100% R#A&=geek)\"><br>\r\n"
				"<textarea name=info cols=80 rows=5\">\r\n"
				"This is a textarea!\r\n"
				"~`!@#$%^&*()_+|-=\\{}[]:\";'<>?,./\r\n"
				"1234567890\r\n"
				"abcdefghijklmnopqrstuvwxyz\r\n"
				"ABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n"
				"</textarea><br>"
				"<input type=file name=file size=80><br>\r\n"
				"<input type=submit value=\"Post Multipart\">\r\n"
				"</form><p>\r\n");
		/* and the quit url */
		WebSrv_ClientSendString(c, "<a href=/Quit>Quit Server</a><p>\r\n");
		
		WebSrv_ClientSendVString(c,"URL=%s<br>\r\n", c->url.url);
		WebSrv_ClientSendVString(c,"\thost=%s<br>\r\n", c->url.host);
		WebSrv_ClientSendVString(c,"\tport=%hu<br>\r\n", c->url.port);
		WebSrv_ClientSendVString(c,"\tpath=%s<br>\r\n", c->url.path);
		WebSrv_ClientSendVString(c,"\tfile=%s<br>\r\n", c->url.file);
		for(i=0;i<c->url.num_params;i++)
		{
			WebSrv_ClientSendVString(c,"\tparams[%d] name=%s size=%d", i, c->url.params[i].name, c->url.params[i].size);
			if(c->url.params[i].filename)
				WebSrv_ClientSendVString(c," filename=%s", c->url.params[i].filename);
			if(c->url.params[i].data)
			{
				WebSrv_ClientSendString(c,"<pre>+++ Begin data +++\r\n");
				WebSrv_ClientSend(c, c->url.params[i].data, c->url.params[i].size);
				WebSrv_ClientSendString(c,"\r\n--- End data ---\r\n</pre>\r\n");
			}
			else
				WebSrv_ClientSendString(c,"<br>\r\n");
		}
		if(c->post_length && c->post)
		{
			WebSrv_ClientSendVString(c,"<pre>--- Post Begin (%d bytes) ---\r\n",c->post_length);
			WebSrv_ClientSendString(c,c->post);
			WebSrv_ClientSendString(c,"\r\n--- Post End ---\r\n</pre>\r\n");
		}
		WebSrv_ClientSendString(c,"</body>\r\n</html>\r\n");
		WebSrv_CloseClient(ws, c);
	}
	//WebSrv_Close(ws); //don't use this here, unless you're going to open ws again...
	WebSrv_Destroy(ws);

	SDLNet_Quit();
	SDL_Quit();
	printf("Testws Ending.\n");
	return(0);
}
